fuss-manager - Segnalazione #773

Detect e visualizzazione fact ansible per le macchine
03/11/2019 12:03 PM - Enrico Zini

Status: In elaborazione Start date: 06/28/2019
Priority: Normale Due date:

Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version: 0.10 Prima validazione interfaccia

Resolution:

Description

Per le macchine per le quali abbiamo accesso come root, possiamo fare un giro di gather fact di ansible e mostrarne alcuni
nell'interfaccia.

Questo pud avere un'utilita generica e dare un meccanismo estensibile per raccogliere informazioni, tipo anche se una macchina
configurata con fuss-client.

Subtasks:
Segnalazione # 855: Visualizzazione delle informazioni delle macchine Nuovo

Related issues:
Related to fuss-manager - Segnalazione #738: Detect macchine configurate con ... Chiuso 02/19/2019
Related to fuss-manager - Segnalazione #829: Controllare che il caricamento d... Chiuso 06/03/2019

Associated revisions

Revision b7ef2212 - 04/30/2019 11:57 AM - Elena Grandi
Start running ansible to get setup data. refs: #773

Revision 56986e90 - 05/04/2019 07:29 PM - Enrico Zini

Prototype a libvirt-based test environment. refs: #773

Revision a93fb9b3 - 05/05/2019 11:54 PM - Enrico Zini

more experiments made with libvirt. refs: #773

Revision 481999d1 - 05/06/2019 02:22 PM - Enrico Zini

Refactored testnet. refs: #773

Revision f338a76d - 05/06/2019 02:24 PM - Enrico Zini
Moved everything to test_network/ except the CLI itself. refs: #773

Revision afe61568 - 05/06/2019 02:40 PM - Enrico Zini
Assign IPs to domains. refs: #773

Revision 4c83eafc - 05/06/2019 02:43 PM - Enrico Zini
Updated test_network README. refs: #773

Revision 07fcfe58 - 05/06/2019 02:53 PM - Enrico Zini

Wait for domains to be started. refs: #773

Revision 2de79d67 - 05/06/2019 03:09 PM - Enrico Zini

More flexible CLI and cleanup stderr noise. refs: #773

03/20/2024 1/7




Revision 73656018 - 05/06/2019 03:17 PM - Enrico Zini
Merge remote-tracking branch 'origin/t748' into t773. refs: #773

Revision dab4d894 - 05/06/2019 04:31 PM - Enrico Zini

Added an ansible setup to run tests on the fuss-test-network machines. refs: #773

Revision ee9701d8 - 05/06/2019 04:41 PM - Enrico Zini

Have the mock network activity match the test network hosts. refs: #773

Revision 0bb38c58 - 05/06/2019 05:09 PM - Enrico Zini

Added host/group vars to connect to test machines. refs: #773

Revision 781ee8b9 - 05/06/2019 05:14 PM - Enrico Zini
Moved test playbooks in playbooks/. refs: #773

Revision d928cc10 - 05/06/2019 06:58 PM - Enrico Zini

Refactored playbook running so it can be wired into manager. refs: #773

Revision 95786b4d - 05/06/2019 07:31 PM - Enrico Zini
Started working on running playbooks. refs: #773

Revision 736ca041 - 05/06/2019 07:47 PM - Enrico Zini

remove nondeterminism. refs: #773

Revision 3946163 - 05/06/2019 08:17 PM - Enrico Zini
Run playbooks and dispatch their output to the hosts involved. refs: #773

Revision ba911919 - 05/22/2019 02:47 PM - Elena Grandi

Start saving a cache of ansible facts. refs: #773

Revision aba68a39 - 05/28/2019 02:23 PM - Elena Grandi

Save a log of facts updates. refs: #773

Revision 7e4f32cf - 05/31/2019 02:40 PM - Enrico Zini
Merge branch 't773'. Fixes: #773

Revision 1b626377 - 05/31/2019 04:40 PM - Enrico Zini
Merge branch 'master' into t773. refs: #773

Revision d5ceec06 - 05/31/2019 05:02 PM - Enrico Zini
Added tabs to machine popup. refs: #773

Revision ¢7333675 - 05/31/2019 06:32 PM - Enrico Zini

New RefreshFacts operation. refs: #773

Revision c481621a - 05/31/2019 06:32 PM - Enrico Zini

Export facts in machine data. refs: #773

Revision 4cb35e9f - 05/31/2019 06:33 PM - Enrico Zini
Added a button to refresh facts. refs: #773
Revision c4fc343b - 05/31/2019 06:33 PM - Enrico Zini

Show last collected facts. refs: #773

Revision c24d3b68 - 05/31/2019 06:35 PM - Enrico Zini

Show in the log when an operation is posted via API. refs: #773

Revision 1d8b6a22 - 05/31/2019 08:00 PM - Enrico Zini

Also show facts log in machine modal. refs: #773

Revision 8e3c92cf - 06/03/2019 02:06 PM - Elena Grandi

Add a timestamp to ansible facts data. refs: #773

Revision 4a866454 - 06/04/2019 12:11 PM - Elena Grandi

Find a machine in the store instead of looking up the mac for the name. refs: #773

Revision 4e9672b3 - 06/28/2019 01:50 PM - Enrico Zini
Sync with master. refs: #773

Revision 426113b0 - 06/28/2019 01:51 PM - Enrico Zini

Merge to master; Ul is not finished, but it needs some analysis to see what is the desired way to present facts. Refs: #773

History

#1 - 03/11/2019 12:03 PM - Elena Grandi

- Related to Segnalazione #738: Detect macchine configurate con fuss-client added

#2 - 03/11/2019 12:07 PM - Elena Grandi

- Assignee set to Elena Grandi

Fare caching in memoria dei dati raccolti.

(nota: riassegnare poi ad Enrico per l'interfaccia)

#3 - 04/02/2019 06:49 PM - Enrico Zini

| dettagli su dove trovare i fact sono in #738

#4 - 04/26/2019 11:57 AM - Elena Grandi

- Status changed from Nuovo to In elaborazione

#5 - 05/02/2019 12:12 PM - Elena Grandi

- Assignee changed from Elena Grandi to Enrico Zini

Implementata la raccolta dei fact, branch t773. | test controllano la presenza di alcuni fact che mi paiono particolarmente utili, (quindi sono un posto
dove & documentato come reperirli).

Ti ripasso il ticket per review, e per la parte di inserimento nell'interfaccia.

#6 - 05/06/2019 07:01 PM - Enrico Zini

- Assignee changed from Enrico Zini to Elena Grandi
https://work.fuss.bz.it/issues/738

Grazie! Ho fatto refactoring per incastrare il tutto nel manager, in modo da poter mandare richieste e ricevere risultati.

Mi piacerebbe fare cache dei fact di ansible in un qualche storage, in modo da poterli sempre mostrare, ed eventualmente dare la possibilita di
aggiornarli o aggiornarli periodicamente.

In teoria, lo store che immagazzina i dati effimeri potrebbe ascoltare HostFactsEvent e salvarsi facts. Se ti sembra una buona idea, puoi
implementarlo?

#7 - 05/07/2019 09:36 AM - Enrico Zini

In questo branch c'é il test tests.test_playbook.TestPlaybook.test_run_playbook che dipende da fuss-test-network, e viene saltato se
fuss-test-network non & su.

Per tirare su la rete di test: fuss-test-network --start --verbose. Serve che I'utente sia nel gruppo libvirt, e che la directory indicata dall'opzione
--storage
sia accessibile e scrivibile dal gruppo libvirt. Dovrebbe dipendere solo da libvirt-clients.

Siccome i test sono opzionali, non importa tirare su fuss-test-network; se un giorno hai un momento per provarlo, pero, magari mi dici se da te parte
senza problemi.

Ho cambiato la mock data source per produrre nomi, IP e MAC corrispondenti a quelli usati da fuss-test-network, cosi usando runserver si potranno
effettivamente far girare playbook sulle macchine di prova.

#8 - 05/14/2019 03:10 PM - Elena Grandi

- Target version changed from 0.5 Run di playbook sui client to 0.6 Gestione di macchine spente

Sposto alla versione successiva per fare la release 0.5; qui manca da fare caching dei dati e poi ripassare ad enrico per l'interfaccia.

Al momento i fact vengono comunque visualizzati quando si € lanciato un playbook.

#9 - 05/30/2019 10:35 AM - Elena Grandi

- Assignee changed from Elena Grandi to Enrico Zini

Backend del caching dei facts implementato, riassegno per review && merge (credo valga la pena mergiarlo per avere un "punto fisso") e poi
implementazione dell'interfaccia.

#10 - 05/31/2019 02:41 PM - Enrico Zini

Visto, discusso, mergiato su master. Lascio aperto il ticket assegnato a me per la parte di visualizzazione
#11 - 05/31/2019 02:45 PM - Anonymous

- Status changed from In elaborazione to Risolto

- % Done changed from 0 to 100

Applicata nel changeset fuss-manager|7e4f32cfbd8e15f7d013291ac5d4b5c9adcd9ebb.
https://work.fuss.bz.it/projects/fuss-manager/repository/fuss-manager/revisions/7e4f32cfbd8e15f7d013291ac5d4b5c9a4cd9e6b

#12 - 05/31/2019 04:41 PM - Enrico Zini

- Status changed from Risolto to In elaborazione

#13 - 05/31/2019 06:22 PM - Enrico Zini

- Assignee changed from Enrico Zini to Elena Grandi

In facts_loaded, the log is filled with information not taken from the event:

@asyncio.coroutine
def facts_loaded(self, evt):
ip = yield from self.name_to_ip (evt.name)
mac = yield from self.ip_to_mac (ip)
machine = self.machines.get (mac)
old_facts_log = machine.facts_log.copy ()
machine.facts_log.append ({
'timestamp': time.time (),
'result': 'SUCCESS',
'details': {},

Is it intentional? Ideally, I'd like to take the timestamp from the event, and set details to the actual facts.

#14 - 05/31/2019 06:24 PM - Enrico Zini

Ah, | get it, the facts are stored only in the machine and not in the log, fair enough.

Would it make sense however to take the timestamp from the event, so it matches when the facts were actually collected?

#15 - 05/31/2019 06:25 PM - Enrico Zini
Also, is it intentional that "facts" is not in STATS_MACHINE_FIELDS ?

#16 - 05/31/2019 07:38 PM - Enrico Zini

Another feature request for the backend: machine.facts currently contains only the key ansible_facts; I'd like to have in it also the timestamp of its
facts log, so that | can see how old are the facts and to which facts log they refer.

Presumably, they refer to the last successful entry in the facts log; still it would be nice to have the timestamp to see how old are the facts without
iterating the facts log backwards.

#17 - 05/31/2019 07:59 PM - Enrico Zini

03/20/2024 5/7



Another issue: if the machine is switched off, facts_failed tries to look up its mac address to get the machine record to update. However, when the
machine is off, IP to MAC resolution does not work, the mac variable is None, self.machines.get(mac) returns None and the rest of the method fails.

Would it be possible / a good idea to look up the machine in the store by name directly, both in facts_loaded and in facts_failed, instead of trying to
resolve its ip and mac?

#18 - 06/03/2019 10:39 AM - Elena Grandi

Enrico Zini ha scritto:

Also, is it intentional that "facts" is not in STATS_MACHINE_FIELDS ?

intenzionale si, non sono sicura che sia la scelta giusta sul lungo periodo.

Se salvare o meno i facts su file credo che possa dipendere da quanto spesso li si richiede: se si tende a chiederli spesso forse non val la pena
salvarli su file, se invece li si vuole richiedere piu raramente vale sicuramente la pena.

Per il momento, credo che faccia comodo non averli salvati per non rendere completamente illeggibile lo stats file, cosa che di tanto in tanto € utile
aprire per fare debugging.

#19 - 06/03/2019 12:04 PM - Elena Grandi

- Related to Segnalazione #829: Controllare che il caricamento degli stats non pialli I'esistente added

#20 - 06/04/2019 12:25 PM - Elena Grandi

- Assignee changed from Elena Grandi to Enrico Zini

Pushato t773 con le modifiche al backend:

e il timestamp & generato sul server in un momento solo e passato dalle varie parti
¢ |la macchina a cui associare i facts & cercata per nome nello store anziché cercare di calcolarne I'ip.

Ho cercato di vedere se fosse facile ricevere gia il mac dall'evento facts loaded, ma mi pareva che spostasse solo la ricerca anziché eliminarla, e
quindi non ne valesse la pena.

#21 - 06/28/2019 12:09 PM - Enrico Zini

- Target version changed from 0.6 Gestione di macchine spente to 0.10 Prima validazione interfaccia

#22 - 06/28/2019 01:53 PM - Enrico Zini

- Assignee deleted (Enrico Zini)
Fatto merge in master. | fact rimangono mostrati in modo grezzo, servira capire in fase di ulteriore studio/validazione dell'interfaccia quale sia il modo
piu utile per mostrare i fact.

Tolgo I'assegnazione del ticket finché non arriviamo a quella fase.
